#ifndef __KLJPEGLS_H
#define __KLJPEGLS_H

#define LUTMAX8 (256)
#define alphaJPEGLS (256)
#define	ceil_half_alphaJPEGLS (alphaJPEGLS/2)
#define reset (64)
#define LUTMAX16 (4501)
#define CREGIONS (9)
#define CONTEXTS1 (CREGIONS*CREGIONS*CREGIONS)
#define CONTEXTS   ((CONTEXTS1+1)/2) /* all regions, with symmetric merging */
#define MAX_C 127
#define MIN_C -128

typedef unsigned short pixel;

#define clip(x,alphaJPEGLS) \
        if(x < 0)  \
         x = 0; \
        else if (x >= alphaJPEGLS) \
         x = alphaJPEGLS - 1;

#define predict(Rb, Ra, Rc)	\
{	\
	register pixel minx;	\
	register pixel maxx;	\
	\
	if (Rb > Ra) {	\
		minx = Ra;	\
		maxx = Rb;	\
	} else {	\
		maxx = Ra;	\
		minx = Rb;	\
	}	\
	if (Rc >= maxx)	\
		Px = minx;	\
	else if (Rc <= minx)	\
		Px = maxx;	\
	else	\
		Px = Ra + Rb - Rc;	\
}

class corectPredict
{
public:
 int N[CONTEXTS],
     B[CONTEXTS],
     C[CONTEXTS];
 corectPredict();
 void initialize();
 unsigned char JPEGLSPredict(unsigned char a, unsigned char b, unsigned char c, unsigned char d, unsigned char x, bool tupXdx=true);
};

#endif
